package com.sun.jmx.snmp.internal;

import com.sun.jmx.snmp.SnmpSecurityException;
import com.sun.jmx.snmp.SnmpStatusException;
import com.sun.jmx.snmp.SnmpTooBigException;
import com.sun.jmx.snmp.SnmpSecurityParameters;
import com.sun.jmx.snmp.SnmpUnknownSecModelException;

public interface SnmpSecuritySubSystem extends SnmpSubSystem
{
    public abstract SnmpSecurityCache createSecurityCache(int p0) throws SnmpUnknownSecModelException;
    
    public abstract void releaseSecurityCache(int p0, SnmpSecurityCache p1) throws SnmpUnknownSecModelException;
    
    public abstract int generateRequestMsg(SnmpSecurityCache p0, int p1, int p2, int p3, byte p4, int p5, SnmpSecurityParameters p6, byte[] p7, byte[] p8, byte[] p9, int p10, byte[] p11) throws SnmpTooBigException, SnmpStatusException, SnmpSecurityException, SnmpUnknownSecModelException;
    
    public abstract int generateResponseMsg(SnmpSecurityCache p0, int p1, int p2, int p3, byte p4, int p5, SnmpSecurityParameters p6, byte[] p7, byte[] p8, byte[] p9, int p10, byte[] p11) throws SnmpTooBigException, SnmpStatusException, SnmpSecurityException, SnmpUnknownSecModelException;
    
    public abstract SnmpSecurityParameters processIncomingRequest(SnmpSecurityCache p0, int p1, int p2, int p3, byte p4, int p5, byte[] p6, byte[] p7, byte[] p8, byte[] p9, byte[] p10, SnmpDecryptedPdu p11) throws SnmpStatusException, SnmpSecurityException, SnmpUnknownSecModelException;
    
    public abstract SnmpSecurityParameters processIncomingResponse(SnmpSecurityCache p0, int p1, int p2, int p3, byte p4, int p5, byte[] p6, byte[] p7, byte[] p8, byte[] p9, byte[] p10, SnmpDecryptedPdu p11) throws SnmpStatusException, SnmpSecurityException, SnmpUnknownSecModelException;
}
